var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { EChain } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync } from "neverthrow";
import { BlockchainErrorMapper } from "../implementations/BlockchainErrorMapper.js";
import { ContractOverrides } from "../interfaces/objects/index.js";
let GasUtils = class GasUtils {
    static getGasFee(providerOrSigner) {
        return ResultAsync.fromPromise(providerOrSigner.getFeeData(), (e) => {
            return BlockchainErrorMapper.buildErrorFromProviderError(EChain.DevDoodle, // TODO: There should be a better way to get the chainID
            e);
        }).map((feeData) => {
            return new ContractOverrides(feeData.maxFeePerGas);
        });
    }
    static getGasPrice(providerOrSigner) {
        return ResultAsync.fromPromise(providerOrSigner.getFeeData(), (e) => {
            return BlockchainErrorMapper.buildErrorFromProviderError(EChain.DevDoodle, // TODO: There should be a better way to get the chainID
            e);
        }).map((feeData) => {
            return new ContractOverrides(null, feeData.gasPrice);
        });
    }
};
GasUtils = __decorate([
    injectable()
], GasUtils);
export { GasUtils };
//# sourceMappingURL=GasUtils.js.map