var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { EVMContractAddress, MinimalForwarderContractError, BigNumberString, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../implementations/BaseContract.js";
import { ContractsAbis } from "../interfaces/objects/index.js";
let MinimalForwarderContract = class MinimalForwarderContract extends BaseContract {
    constructor(providerOrSigner, contractAddress) {
        super(providerOrSigner, contractAddress, ContractsAbis.MinimalForwarderAbi.abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
    }
    getContractAddress() {
        return this.contractAddress;
    }
    getNonce(from) {
        return ResultAsync.fromPromise(this.contract.getNonce(from), (e) => {
            return this.generateError(e, `Unable to call getNonce(${from})`);
        }).map((nonce) => {
            return BigNumberString(nonce.toString());
        });
    }
    verify(request, signature) {
        return ResultAsync.fromPromise(this.contract.verify(request, signature), (e) => {
            return this.generateError(e, `Unable to call verify()`);
        });
    }
    execute(request, signature, overrides) {
        return this.writeToContract("execute", [request, signature], overrides);
    }
    generateContractSpecificError(msg, e, transaction) {
        return new MinimalForwarderContractError(msg, e, transaction);
    }
};
MinimalForwarderContract = __decorate([
    injectable(),
    __metadata("design:paramtypes", [Object, String])
], MinimalForwarderContract);
export { MinimalForwarderContract };
//# sourceMappingURL=MinimalForwarderContract.js.map