import { RewardsFactoryError, BaseURI, BlockchainCommonErrors } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { ContractOverrides, WrappedTransactionResponse } from "../../interfaces/objects";
export interface IRewardsContractFactory {
    deployERC721Reward(name: string, symbol: string, baseURI: BaseURI, overrides?: ContractOverrides, omitGasFee?: boolean): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | RewardsFactoryError>;
    estimateGasToDeployERC721Contract(name: string, symbol: string, baseURI: BaseURI): ResultAsync<ethers.BigNumber, RewardsFactoryError | BlockchainCommonErrors>;
    deployERC20Reward(name: string, symbol: string, overrides?: ContractOverrides, omitGasFee?: boolean): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | RewardsFactoryError>;
    estimateGasToDeployERC20Contract(name: string, symbol: string): ResultAsync<ethers.BigNumber, RewardsFactoryError | BlockchainCommonErrors>;
}
export declare const IRewardsContractFactoryType: unique symbol;
//# sourceMappingURL=IRewardsContractFactory.d.ts.map