import { TransactionResponseError, } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
export class WrappedTransactionResponse {
    constructor(txResponse, contractAddress, signerAddress, functionName, functionParams, abi) {
        this.txResponse = txResponse;
        this.contractAddress = contractAddress;
        this.signerAddress = signerAddress;
        this.functionName = functionName;
        this.functionParams = functionParams;
        this.abi = abi;
    }
    wait() {
        return ResultAsync.fromPromise(this.txResponse.wait(), (e) => {
            return new TransactionResponseError("Unable to call wait() for transaction response.", e.reason);
        });
    }
}
//# sourceMappingURL=WrappedTransactionResponse.js.map